﻿using System.Collections.Generic;

namespace Reborn_Healer.IO
{
    /// <summary>
    /// Provides an uniform interface for loading profiles and saving them.
    /// </summary>
    public interface IProfileLoader
    {
        /// <summary>
        /// Fetches a list of profiles depending on the method.
        /// </summary>
        /// <typeparam name="T">The type of profile to fetch</typeparam>
        /// <returns></returns>
        List<T> GetProfiles<T>() where T : Profile.Profile;

        /// <summary>
        /// Saves the specified profile to the disk.
        /// </summary>
        /// <typeparam name="T">The type of profile to save</typeparam>
        void SaveProfiles<T>(Profile.Profile profile) where T : Profile.Profile;
    }
}