﻿using ff14bot;
using ff14bot.Objects;

namespace Reborn_Healer.Profile.Combat.Conditions
{
    public class BuffCondition : Condition
    {
        [ConditionDescription(typeof(BuffCondition))]
        public enum ValueOptions
        {
            New
        }

        /// <summary>
        /// A list of auras that are potential candidates
        /// </summary>
        public enum Aura
        {
            Petrification = 1,
            Stun = 2,
            Sleep = 3,
            Daze = 4,
            Amnesia = 5,
            Pacification = 6,
            Silence = 7,
            Haste = 8,
            Slow = 9,
            SlowDupe259 = 10,
            Bind = 13,
            Heavy = 14,
            Blind = 15,
            Paralysis = 17,
            Poison = 18,
            Pollen = 19,
            TPBleed = 20,
            HPBoost = 21,
            HPPenalty = 22,
            MPBoost = 23,
            MPPenalty = 24,
            AttackUp = 25,
            AttackDown = 26,
            AccuracyUp = 27,
            AccuracyDown = 28,
            DefenseUp = 29,
            DefenseDown = 30,
            EvasionUp = 31,
            EvasionDown = 32,
            MagicPotencyUp = 33,
            MagicPotencyDown = 34,
            HealingPotencyUp = 35,
            HealingPotencyDown = 36,
            MagicDefenseUp = 37,
            MagicDefenseDown = 38,
            Weakness = 43,
            BrinkofDeath = 44,
            CraftersGrace = 45,
            GatherersGrace = 46,
            Stealth = 47,
            WellFed = 48,
            Medicated = 49,
            Sprint = 50,
            StrengthDown = 51,
            VitalityDown = 52,
            PhysicalDamageUp = 53,
            PhysicalDamageDown = 54,
            PhysicalVulnerabilityDown = 55,
            PhysicalVulnerabilityUp = 56,
            MagicDamageUp = 57,
            MagicDamageDown = 58,
            MagicVulnerabilityDown = 59,
            MagicVulnerabilityUp = 60,
            DeterminationUp = 61,
            DeterminationDown = 62,
            VulnerabilityDown = 63,
            VulnerabilityUp = 64,
            CriticalSkill = 65,
            Terror = 66,
            Leaden = 67,
            Drainstrikes = 68,
            Aspirstrikes = 69,
            Stunstrikes = 70,
            Rampart = 71,
            Convalescence = 72,
            Awareness = 73,
            Sentinel = 74,
            TemperedWill = 75,
            FightorFlight = 76,
            Bulwark = 77,
            SwordOath = 78,
            ShieldOath = 79,
            Cover = 80,
            Covered = 81,
            HallowedGround = 82,
            Foresight = 83,
            Bloodbath = 84,
            Maim = 85,
            Berserk = 86,
            ThrillofBattle = 87,
            Holmgang = 88,
            Vengeance = 89,
            StormsEye = 90,
            Defiance = 91,
            Unchained = 92,
            Wrath = 93,
            WrathII = 94,
            WrathIII = 95,
            WrathIV = 96,
            Infuriated = 97,
            DragonKick = 98,
            Featherfoot = 99,
            InternalRelease = 100,
            TwinSnakes = 101,
            Mantra = 102,
            FistsofFire = 103,
            FistsofEarth = 104,
            FistsofWind = 105,
            TouchofDeath = 106,
            OpoopoForm = 107,
            RaptorForm = 108,
            CoeurlForm = 109,
            PerfectBalance = 110,
            GreasedLightning = 111,
            GreasedLightningII = 112,
            GreasedLightningIII = 113,
            KeenFlurry = 114,
            HeavyThrust = 115,
            LifeSurge = 116,
            BloodforBlood = 117,
            ChaosThrust = 118,
            Phlebotomize = 119,
            PowerSurge = 120,
            Disembowel = 121,
            StraighterShot = 122,
            HawksEye = 123,
            VenomousBite = 124,
            RagingStrikes = 125,
            Freeshot = 126,
            QuellingStrikes = 127,
            Barrage = 128,
            Windbite = 129,
            StraightShot = 130,
            DownpourofDeath = 131,
            QuickerNock = 132,
            Swiftsong = 133,
            SwiftsongDupe173 = 134,
            MagesBallad = 135,
            MagesBalladDupe432 = 136,
            ArmysPaeon = 137,
            ArmysPaeonDupe273 = 138,
            FoeRequiem = 139,
            FoeRequiemDupe434 = 140,
            BattleVoice = 141,
            Chameleon = 142,
            Aero = 143,
            AeroII = 144,
            ClericStance = 145,
            Protect = 146,
            ProtectDupe85 = 147,
            Raise = 148,
            Rebirth = 149,
            MedicaII = 150,
            Stoneskin = 151,
            UnknownX = 152,
            UnknownY = 153,
            ShroudofSaints = 154,
            Freecure = 155,
            Overcure = 156,
            PresenceofMind = 157,
            Regen = 158,
            DivineSeal = 159,
            Surecast = 160,
            Thunder = 161,
            ThunderII = 162,
            ThunderIII = 163,
            Thundercloud = 164,
            Firestarter = 165,
            Succor = 166,
            Swiftcast = 167,
            Manaward = 168,
            Manawall = 169,
            Apocatastasis = 170,
            Ekpyrosis = 171,
            Infirmity = 172,
            AstralFire = 173,
            AstralFireII = 174,
            AstralFireIII = 175,
            UmbralIce = 176,
            UmbralIceII = 177,
            UmbralIceIII = 178,
            Bio = 179,
            Miasma = 180,
            Disease = 181,
            Virus = 182,
            Fever = 183,
            Sustain = 184,
            EyeforanEye = 185,
            EyeforanEyeDupe160 = 186,
            Rouse = 187,
            MiasmaII = 188,
            BioII = 189,
            ShadowFlare = 190,
            Tridisaster = 191,
            Spur = 192,
            SlowDupe379 = 193,
            ShieldWall = 194,
            MightyGuard = 195,
            LastBastion = 196,
            BlazeSpikes = 197,
            IceSpikes = 198,
            ShockSpikes = 199,
            PhysicalVulnerabilityUpDupe307 = 200,
            StunDupe240 = 201,
            VulnerabilityUpDupe341 = 202,
            Boost = 203,
            Enfire = 204,
            Enblizzard = 205,
            Enaero = 206,
            Enstone = 207,
            Enthunder = 208,
            Enwater = 209,
            Doom = 210,
            SharpenedKnife = 211,
            TrueSight = 212,
            PacificationDupe354 = 213,
            Agitation = 214,
            DeterminationDownDupe23 = 215,
            ParalysisDupe16 = 216,
            Triangulate = 217,
            GatheringRateUp = 218,
            GatheringYieldUp = 219,
            GatheringFortuneUp = 220,
            TruthofForests = 221,
            TruthofMountains = 222,
            ByregotsWard = 223,
            NophicasWard = 224,
            Prospect = 225,
            HasteDupe57 = 226,
            MenphinasWard = 228,
            NaldthalsWard = 229,
            LlymlaensWard = 230,
            ThaliaksWard = 231,
            Preparation = 232,
            ArborCall = 233,
            LayoftheLand = 234,
            ChocoBeak = 236,
            ChocoRegen = 237,
            ChocoSurge = 238,
            TheEcho = 239,
            BlessingofLight = 241,
            ArborCallII = 242,
            LayoftheLandII = 243,
            Fracture = 244,
            Sanction = 245,
            Demolish = 246,
            RainofDeath = 247,
            CircleofScorn = 248,
            FlamingArrow = 249,
            Burns = 250,
            InnerQuiet = 251,
            WasteNot = 252,
            SteadyHand = 253,
            GreatStrides = 254,
            Ingenuity = 255,
            IngenuityII = 256,
            WasteNotII = 257,
            Manipulation = 258,
            Innovation = 259,
            Reclaim = 260,
            ComfortZone = 261,
            SteadyHandII = 262,
            VulnerabilityDownDupe476 = 263,
            FleshWound = 264,
            StabWound = 265,
            Concussion = 266,
            BurnsDupe138 = 267,
            Frostbite = 268,
            Windburn = 269,
            Sludge = 270,
            Electrocution = 271,
            Dropsy = 272,
            Bleeding = 273,
            Recuperation = 274,
            Poison1 = 275,
            VoiceofValor = 276,
            Rehabilitation = 279,
            BindDupe469 = 280,
            PhysicalDamageDownDupe306 = 281,
            ManaModulation = 282,
            DropsyDupe418 = 283,
            BurnsDupe299 = 284,
            FrostbiteDupe486 = 285,
            WindburnDupe145 = 286,
            SludgeDupe5 = 287,
            ElectrocutionDupe256 = 288,
            DropsyDupe50 = 289,
            DeterminationUpDupe490 = 290,
            HundredFists = 291,
            Fetters = 292,
            SkillSpeedUp = 293,
            SpellSpeedUp = 294,
            Goldbile = 295,
            Hysteria = 296,
            Adloquium = 297,
            SacredSoil = 298,
            SacredSoilDupe309 = 299,
            DeterminationUpDupe348 = 300,
            CriticalStrikes = 301,
            GoldLung = 302,
            Burrs = 303,
            Aetherflow = 304,
            TheDragonsCurse = 305,
            InnerDragon = 306,
            VoiceofValorDupe369 = 307,
            Curl = 310,
            EarthenWard = 311,
            EarthenFury = 312,
            RadiantShield = 313,
            Inferno = 314,
            WhisperingDawn = 315,
            FeyCovenant = 316,
            FeyIllumination = 317,
            FeyGlow = 318,
            FeyLight = 319,
            BleedingDupe392 = 320,
            Gungnir = 321,
            CrystalVeil = 322,
            ReducedImmunity = 323,
            Greenwrath = 324,
            Invincibility = 325,
            LightningCharge = 326,
            IceCharge = 327,
            HeartoftheMountain = 328,
            Modification = 329,
            HasteDupe310 = 330,
            MagicVulnerabilityDownDupe416 = 331,
            PhysicalDamageUpDupe213 = 332,
            AllaganRot = 333,
            AllaganImmunity = 334,
            Firestream = 335,
            SequenceAB1 = 336,
            SequenceAP1 = 337,
            SequenceAS1 = 338,
            BleedingDupe262 = 339,
            PhysicalField = 340,
            AetherialField = 341,
            RepellingSpray = 342,
            BleedingDupe465 = 343,
            Neurolink = 344,
            Recharge = 345,
            WaxenFlesh = 346,
            Pox = 347,
            Disseminate = 348,
            SteelScales = 349,
            VulnerabilityDownDupe128 = 350,
            Rancor = 351,
            Spjot = 352,
            BraveNewWorld = 353,
            LiveofftheLand = 354,
            WhatYouSee = 355,
            EatfromtheHand = 356,
            InControl = 357,
            MeatandMead = 360,
            ThatWhichBindsUs = 361,
            ProperCare = 362,
            BackonYourFeet = 363,
            ReducedRates = 364,
            TheHeatofBattle = 365,
            AMansBestFriend = 366,
            EarthandWater = 367,
            HelpingHand = 368,
        }

        /// <summary>
        /// The aura this condition relies on
        /// </summary>
        public Aura ConditionalAura { get; set; }

        public bool Required { get; set; }

        public bool InCombat { get; set; }

        public override bool Evaluate(Character context)
        {
            //TODO: We should investigate into using proper scoping here
            if (InCombat && !Core.Player.InCombat || !InCombat && Core.Player.InCombat)
                return false;

            if (Required)
                return context.HasAura((int)ConditionalAura);
            return !context.HasAura((int)ConditionalAura);
        }

        public override string Name
        {
            get { return "Has " + ConditionalAura.ToString() + "?"; }
        }
    }
}