﻿using System;

namespace Reborn_Healer.Profile.Combat.Conditions
{
    /// <summary>
    /// Describes attribute data used to generate a skill view on the skill editor form.
    /// This attribute takes no parameters -- it's used for declarative use only.
    /// </summary>
    public class ConditionDescriptionAttribute : Attribute
    {
        /// <summary>
        /// This is the type that this enum / class maps to on the condition tree.
        /// </summary>
        public Type ConditionMapping { get; set; }

        public ConditionDescriptionAttribute(Type conditionMapping)
        {
            ConditionMapping = conditionMapping;
        }
    }
}