﻿using System.Collections;
using System.Collections.Generic;

namespace Reborn_Healer.Profile.Combat
{
    /// <summary>
    /// A collection of <see cref="SkillEntry"/> that belong to a profile.
    /// This allows for deep creation of multiple entries.
    /// </summary>
    public class SkillCollection : IEnumerable<SkillEntry>
    {
        public void AddEntry(SkillEntry entry)
        {
            _skillEntries.Add(entry);
        }

        public void RemoveEntry(SkillEntry entry)
        {
            _skillEntries.Remove(entry);
        }

        /// <summary>
        /// An internal collection of our skills
        /// </summary>
        private List<SkillEntry> _skillEntries = new List<SkillEntry>();

        public IEnumerator<SkillEntry> GetEnumerator()
        {
            return _skillEntries.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
    }
}