﻿using Reborn_Healer.Profile.Combat.Conditions;
using Reborn_Healer.Tasks.Combat;
using System.Collections.Generic;

namespace Reborn_Healer.Profile.Combat
{
    /// <summary>
    /// A entry in the <see cref="CombatProfile"/> -- these stores actions that can be executed on specific combat tasks.
    /// </summary>
    public class SkillEntry
    {
        public SkillEntry()
        {
        }

        public SkillEntry(uint skillId)
        {
            SkillId = skillId;
            Conditions = new List<Condition>();
        }

        /// <summary>
        /// The Skill ID for this entry and what will be mapped to it
        /// </summary>
        public uint SkillId { get; set; }

        /// <summary>
        /// The target scoping we'd like to apply this skill to.
        /// </summary>
        public Scope Target { get; set; }

        /// <summary>
        /// Conditions that are required for this skill to be executed.
        /// </summary>
        public List<Condition> Conditions { get; set; }

        /// <summary>
        /// Returns a human readable name for this string.
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            //TODO: Return something a bit more readable
            return "A Skill Entry";
        }
    }
}