﻿namespace Reborn_Healer.Profile
{
    /// <summary>
    /// A profile represents an abstract configuration for a given mode that Reborn supports.
    /// This class is used in the profile manager for different plugins.
    /// </summary>
    public abstract class Profile
    {
        /// <summary>
        /// The name of this profile -- this is usually the same as the filename it has been saved under but this is not always required.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// The unique Id for this given profile
        /// </summary>
        public int Id { get; set; }
    }
}