﻿using System.Threading;
using ff14bot;
using ff14bot.Managers;
using Reborn_Healer.Profile.Combat;
using Reborn_Healer.Tasks.Combat;
using System;

namespace Reborn_Healer.Tasks
{
    /// <summary>
    /// This is a stub for now.
    /// </summary>
    public class CombatTask : IRebornTask<CombatProfile>
    {
        #region Variables

        private bool _IsAlive;
        private SkillGenerator _skillGenerator = new SkillGenerator(null);
        private CombatProfile _runningProfile;

        #region Event Handler for combat tasker to set IsAlive bool

        public delegate void combatTaskRunning(bool value);

        public event combatTaskRunning taskRunning;

        #endregion Event Handler for combat tasker to set IsAlive bool

        #endregion Variables

        #region Accessors

        /// <summary>
        /// Public bool for update method setting on and off.
        /// </summary>
        public bool IsAlive
        {
            get { return _IsAlive; }
            set
            {
                _IsAlive = value;
                taskRunning(_IsAlive);
            }
        }

        /// <summary>
        /// So bot can pass information from user to our combat tasker to know which mode he wants to use.
        /// </summary>
        public string BotMode { get; set; }

        /// <summary>
        /// Our current running profile for this given instance
        /// </summary>
        public CombatProfile RunningProfile
        {
            get { return _runningProfile; }
            set
            {
                _runningProfile = value;
                _skillGenerator.SkillProfile = value;
            }
        }

        #endregion Accessors

        #region Update Method

        public void Update()
        {
            if (RunningProfile != null)
            {
                while (_IsAlive)
                {
                    switch (BotMode)
                    {
                        case "Grind":
                            throw new NotImplementedException("Sorry not rdy for usage.");
                        case "Assist":
                            PerformAssist();
                            break;

                        case "Fate":
                            throw new NotImplementedException("Sorry not rdy for usage.");
                        case "Questing":
                            throw new NotImplementedException("Sorry not rdy for usage.");
                    }
                }
            }
        }

        #endregion Update Method

        #region Assist Mode

        /// <summary>
        /// Performs combat mode assist commands.
        /// </summary>
        private void PerformAssist()
        {
            // It's safe to exit out if the player is casting right now
            if (Core.Player.IsCasting || MovementManager.IsMoving)
                return;

            // NOTE: This allows for debuffs to kick in
            Thread.Sleep(800);
            

            // Grab next usable skill
            var nextSkill = _skillGenerator.GetNextEntry();

            if (nextSkill != null && Actionmanager.CanCast(nextSkill.SkillEntry.SkillId, nextSkill.Target))
                Actionmanager.DoAction(nextSkill.SkillEntry.SkillId, nextSkill.Target);
        }

        #endregion Assist Mode
    }
}