﻿namespace Reborn_Healer.Tasks
{
    public interface IRebornTask
    {
        /// <summary>
        /// This method is invoked when a time slice to update is presented.
        /// </summary>
        void Update();
    }

    /// <summary>
    /// A reborn task that can be used -- these map out modules that can be used.
    /// </summary>
    public interface IRebornTask<T> : IRebornTask where T : Profile.Profile
    {
        /// <summary>
        /// The type of profile this task will be using, along with the currently active running one.
        /// </summary>
        T RunningProfile { get; }
    }
}